//
//  KSTransCreationManager.h
//  kinescopeClient
//
//  Created by ihawk on 7/18/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "transmission.h"
#import "makemeta.h"

@interface KSTransCreationManager : NSObject {

  NSString *sourceFilePath;
  NSString *torrentPath;
  id delegate;
  
  NSNumber *percentDone;
  
  BOOL torrentTaskDone;
  BOOL torrentTaskAborted;
  
  tr_metainfo_builder_t * fInfo;
}

-(id)initWithSourceFile:(NSString *)file torrentPath:(NSString *)torrentPath delegate:(id)delegate;

idAccessor_h(torrentPath, setTorrentPath)

-(bool)isDone;

//-(void)start;
//-(NSData *)runSynchronous;
//-(void)abort;

//+(KSTorrentCreationManager *)createTorrentForFile:(NSString *)file atPath:(NSString *)torrentPath delegate:(id)delegate;
+(NSData *)createTorrentSynchronouslyForFile:(NSString *)file atPath:(NSString *)torrentPath;
+(KSTransCreationManager *)createCreationManager:(NSString *)file torrentPath:(NSString *)torrentPath delegate:(id)del;
-(void)update;
-(void)abort;
-(void)start;

@end


@interface NSObject (KSTransTorrentCreationManagerDelegate)
-(void)torrentCreationManager:(KSTransCreationManager *)manager updatedPercentDone:(NSNumber *)percentDone;
-(void)torrentCreationSucceeded:(KSTransCreationManager *)manager torrentData:(NSData *)torrentData torrentPath:(NSString*)torrentPath;
-(void)torrentCreationFailed:(KSTransCreationManager *)manager;
@end




